#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>

void FOSSinit(int);
void FOSSputc(int, unsigned char);
int FOSSgetc(int);
unsigned int FOSSstatus(int);
unsigned int FOSSbaud(int, unsigned char);
void FOSSflowCtrl(int, unsigned char);
unsigned int FOSSpeek(int);
unsigned int FOSSctlck(int, unsigned char);
unsigned int FOSSwriteblk(int, int, unsigned char *);

void main(void)
{
	unsigned int c;

	FOSSinit(4);
	FOSSbaud(4, 0x23);	// 38400,N,8,1

	while (1)
	{
      if (kbhit())
      {
        c = getch();
        if (c == 0x1b) break;
        FOSSputc(4,c);
      }

//      if (FOSSpeek(4) != 0xffff)
//      {
//        c= FOSSgetc(4);
//		  putchar(c);
//      }

		if (FOSSstatus(4) & 0x100)
		{
        c= FOSSgetc(4);
		  putchar(c);
		}

		if (FOSSctlck(4,1))
			printf("\r\nGot CTLC/CTLK\n");
	}
}

void FOSSinit(int port)
{
	_DX= port;
	_AX= 0x0400;
asm	int 0x14
}

unsigned int FOSSbaud(int port, unsigned char baud)
{
	_DX= port;
	_AX= baud;
asm	int 0x14

	return(_AX);
}

void FOSSputc(int port, unsigned char c)
{
	_DX= port;
	_AX= c;
	_AX |= 0x0100;
asm	int 0x14
}

int FOSSgetc(int port)
{
	_DX= port;
	_AX= 0x0200;
asm	int 0x14

	return(_AX);
}

unsigned int FOSSstatus(int port)
{
	_DX= port;
	_AX= 0x0300;
asm	int 0x14

	return(_AX);
}

void FOSSflowCtrl(int port, unsigned char mode)
{
	_DX= port;
	_AX= mode;
	_AX |= 0x0f00;
asm	int 0x14
}

unsigned int FOSSpeek(int port)
{
	_DX= port;
	_AX= 0x0c00;
asm	int 0x14

	return(_AX);
}

unsigned int FOSSctlck(int port, unsigned char flag)
{
	_DX= port;
	_AX= flag;
	_AX |= 0x1000;
asm	int 0x14

	return(_AX);
}

unsigned int FOSSwriteblk(int port, int count, unsigned char *buffer)
{
	_DX= port;
	_AX= 0x1900;
	_CX= count;
	_ES= FP_SEG(buffer);
	_DI= FP_OFF(buffer);
asm	int 0x14

	return(_AX);
}
