 d - key read, no timeout  0DA1
 e - key read, w/wait      0DAF
 11 - set cursor           0E6A
 12 - get cursor           0E73
 13 - single char write    0E7F

-dw 12e
            0     1    2   3    4     5   6    7
1BBB:012E  0650 0734 07B8 084C 09F8 0BCC 0C44 0C8A
            8    9    a    b    c    d    e    f
1BBB:013E  0C96 0CB2 0CE0 0D30 0DBE 0DA1 0DAF 0E3A
            10   11   12   13   14   15   16   17
1BBB:014E  0DEA 0E6A 0E73 0E7F 0EE6 0EAC 0FB4 1096
1BBB:015E  10BE 1162 11FA 126D 01AC 0635 01AC 5350
1BBB:016E  5251 5756 061E 8B55 FBEC 8CFC 8ECB 3ADB
1BBB:017E  0C26 7601 8040 7EFC 0F72 FC80 767F 8047
1BBB:018E  BFFC 5376 FC80 73FE 8A09 0C1E 8801 0E5E
1BBB:019E  0CEB DB33 DC2A CBFE E3D1 A7FF 0168 06FF
1BBB:01AE  021F 21A3 B802 FFFF 4689 5D10 1F07 5E5F
1BBB:01BE  595A 585B FFCF 2306 A302 022B FF32 DC8A
1BBB:01CE  E3D1 A7FF 012E EC80 0A7E 75E4 E903 0264
1BBB:01DE  84E9 0002 0000 8000 80EC DC8A FF32 E3D1
1BBB:01EE  E3D1 1E03 012C 078B 470B 7402 8BB1 8B0F
1BBB:01FE  0257 FA9C 8758 1046 0E89 01E1 1689 01E3
1BBB:020E  075D 5F1F 5A5E 5B59 2E9D 1EFF 01E1 C6CF
1BBB:021E  0001 0000 0800 4D00 00F8 00F0 0000 0011
-u 650

d - key read, no timeout  0DA1
=========================================================
1BBB:0DA1 B401           MOV	AH,01 
1BBB:0DA3 CD16           INT	16 
1BBB:0DA5 B400           MOV	AH,00 
1BBB:0DA7 7503           JNZ	0DAC      ; if not zero, we got a key
1BBB:0DA9 B8FFFF         MOV	AX,FFFF   ; no key hits avail
1BBB:0DAC E907F4         JMP	01B6 

e - key read, w/wait      0DAF
=========================================================
1BBB:0DAF 32E4           XOR	AH,AH 
1BBB:0DB1 CD16           INT	16 
1BBB:0DB3 3C03           CMP	AL,03 ; whats a 3?
1BBB:0DB5 7503           JNZ	0DBA  ; all done if not a 3(ETX)
1BBB:0DB7 E8CAFF         CALL	0D84  ; key1(for a 3)
1BBB:0DBA E9F9F3         JMP	01B6  ; done
key1:
1BBB:0D84 833E2D0200     CMP	Word Ptr [022D],+00 
1BBB:0D89 7415           JZ	0DA0 
1BBB:0D8B 56             PUSH	SI 
1BBB:0D8C 50             PUSH	AX 
1BBB:0D8D 8B362F02       MOV	SI,[022F] ; keyboard tail ctr
1BBB:0D91 A13102         MOV	AX,[0231] ; keyboard head ctr
1BBB:0D94 0BC6           OR	AX,SI     ; compare
1BBB:0D96 7406           JZ	0D9E      ; done
1BBB:0D98 1E             PUSH	DS        ; else grab new key and incr tail
1BBB:0D99 8ED8           MOV	DS,AX 
1BBB:0D9B FE04           INC	Byte Ptr [SI] 
1BBB:0D9D 1F             POP	DS 
1BBB:0D9E 58             POP	AX 
1BBB:0D9F 5E             POP	SI 
1BBB:0DA0 C3             RET	 


 11 - set cursor           0E6A
=======================================================================
1BBB:0E6A 33DB           XOR	BX,BX 
1BBB:0E6C B402           MOV	AH,02 
1BBB:0E6E CD10           INT	10 
1BBB:0E70 E946F3         JMP	01B9 

12 - get cursor           0E73
=======================================================================
1BBB:0E73 33DB           XOR	BX,BX 
1BBB:0E75 B403           MOV	AH,03 
1BBB:0E77 CD10           INT	10 
1BBB:0E79 89560A         MOV	[BP+0A],DX 
1BBB:0E7C E93AF3         JMP	01B9 

13 - single char write    0E7F
               Input:    AH = 13h
                         AL = Character to display
=======================================================================
1BBB:0E7F 833E680E00     CMP	Word Ptr [0E68],+00 
1BBB:0E84 741D           JZ	0EA3  ; alternative routine
1BBB:0E86 3C09           CMP	AL,09 ; is char a tab?
1BBB:0E88 7514           JNZ	0E9E  ; if not goto e9e
1BBB:0E8A 33DB           XOR	BX,BX ;   char is a tab
1BBB:0E8C B403           MOV	AH,03 ;   setup
1BBB:0E8E CD10           INT	10    ;   bios read cusor pos dh=row, dl=col
1BBB:0E90 83E207         AND	DX,+07;   mask curcol with 7

1BBB:0E93 83F207         XOR	DX,+07;   dx = remaining need to land on 8 col.
1BBB:0E96 8BCA           MOV	CX,DX ;  cx = dx count
1BBB:0E98 B020           MOV	AL,20 ; al=space
1BBB:0E9A CD29           INT	29    ; send to screen
1BBB:0E9C E2FC           LOOP	0E9A  ; send any more needed
not_a_tab:
1BBB:0E9E CD29           INT	29    ; send out char to scr
1BBB:0EA0 E916F3         JMP	01B9  ; done

alternative:
1BBB:0EA3 B402           MOV	AH,02 ; ah=2 char out to screen, dos
1BBB:0EA5 8AD0           MOV	DL,AL 
1BBB:0EA7 CD21           INT	21    ; dos
1BBB:0EA9 E90DF3         JMP	01B9  ; done

1BBB:0EAC B40E           MOV	AH,0E 
1BBB:0EAE B307           MOV	BL,07 
1BBB:0EB0 CD10           INT	10 
1BBB:0EB2 E904F3         JMP	01B9 
==================================================================


1BBB:0650 80FAFF         CMP	DL,FF 
1BBB:0653 7503           JNZ	0658 
1BBB:0655 E9F401         JMP	084C 
1BBB:0658 E841FE         CALL	049C 
1BBB:065B 7205           JB	0662 
1BBB:065D 833D00         CMP	Word Ptr [DI],+00 
1BBB:0660 756E           JNZ	06D0 
1BBB:0662 8BDA           MOV	BX,DX 
-u650 e3a

1BBB:0650 80FAFF         CMP	DL,FF 
1BBB:0653 7503           JNZ	0658 
1BBB:0655 E9F401         JMP	084C 
1BBB:0658 E841FE         CALL	049C 
1BBB:065B 7205           JB	0662 
1BBB:065D 833D00         CMP	Word Ptr [DI],+00 
1BBB:0660 756E           JNZ	06D0 
1BBB:0662 8BDA           MOV	BX,DX 
1BBB:0664 83E30F         AND	BX,+0F 
1BBB:0667 D1E3           SHL	BX,1 
1BBB:0669 8B8F0209       MOV	CX,[BX+0902] 
1BBB:066D 83BF9A09FF     CMP	Word Ptr [BX+099A],-01 
1BBB:0672 7407           JZ	067B 
1BBB:0674 251FFF         AND	AX,FF1F 
1BBB:0677 0B879A09       OR	AX,[BX+099A] 
1BBB:067B D1EB           SHR	BX,1 
1BBB:067D 80BFDA09FF     CMP	Byte Ptr [BX+09DA],FF 
1BBB:0682 7406           JZ	068A 
1BBB:0684 24E0           AND	AL,E0 
1BBB:0686 0A87DA09       OR	AL,[BX+09DA] 
1BBB:068A 8BD8           MOV	BX,AX 
1BBB:068C D1EB           SHR	BX,1 
1BBB:068E D1EB           SHR	BX,1 
1BBB:0690 D1EB           SHR	BX,1 
1BBB:0692 D1EB           SHR	BX,1 
1BBB:0694 83E30E         AND	BX,+0E 
1BBB:0697 81C33302       ADD	BX,0233 
1BBB:069B 8BD1           MOV	DX,CX 
1BBB:069D 83C203         ADD	DX,+03 
1BBB:06A0 50             PUSH	AX 
1BBB:06A1 B080           MOV	AL,80 
1BBB:06A3 FA             CLI	 
1BBB:06A4 EE             OUT	DX,AL 
1BBB:06A5 8B07           MOV	AX,[BX] 
1BBB:06A7 8BD1           MOV	DX,CX 
1BBB:06A9 83C201         ADD	DX,+01 
1BBB:06AC 86E0           XCHG	AH,AL 
1BBB:06AE EE             OUT	DX,AL 
1BBB:06AF 83C2FF         ADD	DX,-01 
1BBB:06B2 86E0           XCHG	AH,AL 
1BBB:06B4 EE             OUT	DX,AL 
1BBB:06B5 83C203         ADD	DX,+03 
1BBB:06B8 58             POP	AX 
1BBB:06B9 241F           AND	AL,1F 
1BBB:06BB EE             OUT	DX,AL 
1BBB:06BC 83C2FE         ADD	DX,-02 
1BBB:06BF 32C0           XOR	AL,AL 
1BBB:06C1 EE             OUT	DX,AL 
1BBB:06C2 FB             STI	 
1BBB:06C3 83C204         ADD	DX,+04 
1BBB:06C6 EC             IN	AL,DX 
1BBB:06C7 8AE0           MOV	AH,AL 
1BBB:06C9 83C201         ADD	DX,+01 
1BBB:06CC EC             IN	AL,DX 
1BBB:06CD E9E6FA         JMP	01B6 
1BBB:06D0 52             PUSH	DX 
1BBB:06D1 8BD8           MOV	BX,AX 
1BBB:06D3 D1EB           SHR	BX,1 
1BBB:06D5 D1EB           SHR	BX,1 
1BBB:06D7 D1EB           SHR	BX,1 
1BBB:06D9 D1EB           SHR	BX,1 
1BBB:06DB 83E30E         AND	BX,+0E 
1BBB:06DE 817E0EDC69     CMP	Word Ptr [BP+0E],69DC 
1BBB:06E3 750A           JNZ	06EF 
1BBB:06E5 817E0CDC69     CMP	Word Ptr [BP+0C],69DC 
1BBB:06EA 7503           JNZ	06EF 
1BBB:06EC 83C310         ADD	BX,+10 
1BBB:06EF 81C33302       ADD	BX,0233 
1BBB:06F3 837D46FF       CMP	Word Ptr [DI+46],-01 
1BBB:06F7 7403           JZ	06FC 
1BBB:06F9 8D5D46         LEA	BX,[DI+46] 
1BBB:06FC 807D18FF       CMP	Byte Ptr [DI+18],FF 
1BBB:0700 7403           JZ	0705 
1BBB:0702 8A4518         MOV	AL,[DI+18] 
1BBB:0705 8BD1           MOV	DX,CX 
1BBB:0707 83C203         ADD	DX,+03 
1BBB:070A 50             PUSH	AX 
1BBB:070B B080           MOV	AL,80 
1BBB:070D FA             CLI	 
1BBB:070E EE             OUT	DX,AL 
1BBB:070F 8B07           MOV	AX,[BX] 
1BBB:0711 83C2FE         ADD	DX,-02 
1BBB:0714 86E0           XCHG	AH,AL 
1BBB:0716 EE             OUT	DX,AL 
1BBB:0717 83C2FF         ADD	DX,-01 
1BBB:071A 86E0           XCHG	AH,AL 
1BBB:071C EE             OUT	DX,AL 
1BBB:071D 83C203         ADD	DX,+03 
1BBB:0720 58             POP	AX 
1BBB:0721 241F           AND	AL,1F 
1BBB:0723 EE             OUT	DX,AL 
1BBB:0724 83C2FE         ADD	DX,-02 
1BBB:0727 B00F           MOV	AL,0F 
1BBB:0729 EE             OUT	DX,AL 
1BBB:072A FB             STI	 
1BBB:072B 0B07           OR	AX,[BX] 
1BBB:072D 894522         MOV	[DI+22],AX 
1BBB:0730 5A             POP	DX 
1BBB:0731 E91801         JMP	084C 
1BBB:0734 80FAFF         CMP	DL,FF 
1BBB:0737 7503           JNZ	073C 
1BBB:0739 E91001         JMP	084C 
1BBB:073C E85DFD         CALL	049C 
1BBB:073F 7205           JB	0746 
1BBB:0741 833D00         CMP	Word Ptr [DI],+00 
1BBB:0744 752D           JNZ	0773 
1BBB:0746 8BDA           MOV	BX,DX 
1BBB:0748 D1E3           SHL	BX,1 
1BBB:074A 8B8F0209       MOV	CX,[BX+0902] 
1BBB:074E 8BD1           MOV	DX,CX 
1BBB:0750 83C205         ADD	DX,+05 
1BBB:0753 50             PUSH	AX 
1BBB:0754 EC             IN	AL,DX 
1BBB:0755 A820           TEST	AL,20                         ;' ' 
1BBB:0757 7507           JNZ	0760 
1BBB:0759 FB             STI	 
1BBB:075A FF1E2406       CALL	FAR [0624] 
1BBB:075E EBF4           JMP	0754 
1BBB:0760 58             POP	AX 
1BBB:0761 8BD1           MOV	DX,CX 
1BBB:0763 EE             OUT	DX,AL 
1BBB:0764 8AE0           MOV	AH,AL 
1BBB:0766 83C205         ADD	DX,+05 
1BBB:0769 EC             IN	AL,DX 
1BBB:076A 86E0           XCHG	AH,AL 
1BBB:076C FF1E2C06       CALL	FAR [062C] 
1BBB:0770 E943FA         JMP	01B6 
1BBB:0773 52             PUSH	DX 
1BBB:0774 8B5532         MOV	DX,[DI+32] 
1BBB:0777 395526         CMP	[DI+26],DX 
1BBB:077A 7507           JNZ	0783 
1BBB:077C FB             STI	 
1BBB:077D FF1E2406       CALL	FAR [0624] 
1BBB:0781 EBF4           JMP	0777 
1BBB:0783 FA             CLI	 
1BBB:0784 8B5D2A         MOV	BX,[DI+2A] 
1BBB:0787 8807           MOV	[BX],AL 
1BBB:0789 43             INC	BX 
1BBB:078A 3B5D30         CMP	BX,[DI+30] 
1BBB:078D 7603           JBE	0792 
1BBB:078F 8B5D2E         MOV	BX,[DI+2E] 
1BBB:0792 895D2A         MOV	[DI+2A],BX 
1BBB:0795 806517BF       AND	Byte Ptr [DI+17],BF 
1BBB:0799 FF4526         INC	Word Ptr [DI+26] 
1BBB:079C 3B5526         CMP	DX,[DI+26] 
1BBB:079F 7504           JNZ	07A5 
1BBB:07A1 806517DF       AND	Byte Ptr [DI+17],DF 
1BBB:07A5 FB             STI	 
1BBB:07A6 837D2601       CMP	Word Ptr [DI+26],+01 
1BBB:07AA 7503           JNZ	07AF 
1BBB:07AC E830FC         CALL	03DF 
1BBB:07AF FF1E2C06       CALL	FAR [062C] 
1BBB:07B3 5A             POP	DX 
1BBB:07B4 E99500         JMP	084C 
1BBB:07B7 0080FAFF       ADD	[BX+SI+FFFA],AL 
1BBB:07BB 7503           JNZ	07C0 
1BBB:07BD E98C00         JMP	084C 
1BBB:07C0 E8D9FC         CALL	049C 
1BBB:07C3 7205           JB	07CA 
1BBB:07C5 833D00         CMP	Word Ptr [DI],+00 
1BBB:07C8 7527           JNZ	07F1 
1BBB:07CA 8BDA           MOV	BX,DX 
1BBB:07CC D1E3           SHL	BX,1 
1BBB:07CE 8B8F0209       MOV	CX,[BX+0902] 
1BBB:07D2 8BD1           MOV	DX,CX 
1BBB:07D4 8BD1           MOV	DX,CX 
1BBB:07D6 83C205         ADD	DX,+05 
1BBB:07D9 EC             IN	AL,DX 
1BBB:07DA A801           TEST	AL,01 
1BBB:07DC 7507           JNZ	07E5 
1BBB:07DE FB             STI	 
1BBB:07DF FF1E2406       CALL	FAR [0624] 
1BBB:07E3 EBF4           JMP	07D9 
1BBB:07E5 8BD1           MOV	DX,CX 
1BBB:07E7 EC             IN	AL,DX 
1BBB:07E8 32E4           XOR	AH,AH 
1BBB:07EA FF1E2C06       CALL	FAR [062C] 
1BBB:07EE E9C5F9         JMP	01B6 
1BBB:07F1 837D3400       CMP	Word Ptr [DI+34],+00 
1BBB:07F5 7507           JNZ	07FE 
1BBB:07F7 FB             STI	 
1BBB:07F8 FF1E2406       CALL	FAR [0624] 
1BBB:07FC EBF3           JMP	07F1 
1BBB:07FE 32E4           XOR	AH,AH 
1BBB:0800 8B5D38         MOV	BX,[DI+38] 
1BBB:0803 8A07           MOV	AL,[BX] 
1BBB:0805 43             INC	BX 
1BBB:0806 3B5D3E         CMP	BX,[DI+3E] 
1BBB:0809 7603           JBE	080E 
1BBB:080B 8B5D3C         MOV	BX,[DI+3C] 
1BBB:080E 895D38         MOV	[DI+38],BX 
1BBB:0811 FF4D34         DEC	Word Ptr [DI+34] 
1BBB:0814 894610         MOV	[BP+10],AX 
1BBB:0817 F6451201       TEST	Byte Ptr [DI+12],01 
1BBB:081B 7427           JZ	0844 
1BBB:081D 8B5D44         MOV	BX,[DI+44] 
1BBB:0820 395D34         CMP	[DI+34],BX 
1BBB:0823 731F           JNB	0844 
1BBB:0825 FA             CLI	 
1BBB:0826 8BD1           MOV	DX,CX 
1BBB:0828 83C204         ADD	DX,+04 
1BBB:082B EC             IN	AL,DX 
1BBB:082C 0D0200         OR	AX,0002 
1BBB:082F EB00           JMP	0831 
1BBB:0831 EE             OUT	DX,AL 
1BBB:0832 806512FE       AND	Byte Ptr [DI+12],FE 
1BBB:0836 F6450F08       TEST	Byte Ptr [DI+0F],08 
1BBB:083A 7407           JZ	0843 
1BBB:083C C6451311       MOV	Byte Ptr [DI+13],11 
1BBB:0840 E89CFB         CALL	03DF 
1BBB:0843 FB             STI	 
1BBB:0844 FF1E2C06       CALL	FAR [062C] 
1BBB:0848 E96EF9         JMP	01B9 
1BBB:084B 0080FAFF       ADD	[BX+SI+FFFA],AL 
1BBB:084F 7509           JNZ	085A 
1BBB:0851 B80800         MOV	AX,0008 
1BBB:0854 80CC60         OR	AH,60                         ;'`' 
1BBB:0857 E95CF9         JMP	01B6 
1BBB:085A E83FFC         CALL	049C 
1BBB:085D 7315           JNB	0874 
1BBB:085F 8BDA           MOV	BX,DX 
1BBB:0861 D1E3           SHL	BX,1 
1BBB:0863 8B970209       MOV	DX,[BX+0902] 
1BBB:0867 83C205         ADD	DX,+05 
1BBB:086A EC             IN	AL,DX 
1BBB:086B 8AE0           MOV	AH,AL 
1BBB:086D 83C201         ADD	DX,+01 
1BBB:0870 EC             IN	AL,DX 
1BBB:0871 E942F9         JMP	01B6 
1BBB:0874 8A6517         MOV	AH,[DI+17] 
1BBB:0877 8A4516         MOV	AL,[DI+16] 
1BBB:087A 80E49F         AND	AH,9F 
1BBB:087D 8B5526         MOV	DX,[DI+26] 
1BBB:0880 3B5532         CMP	DX,[DI+32] 
1BBB:0883 740A           JZ	088F 
1BBB:0885 80CC20         OR	AH,20                         ;' ' 
1BBB:0888 0BD2           OR	DX,DX 
1BBB:088A 7503           JNZ	088F 
1BBB:088C 80CC40         OR	AH,40                         ;'@' 
1BBB:088F 80E4FE         AND	AH,FE 
1BBB:0892 837D3400       CMP	Word Ptr [DI+34],+00 
1BBB:0896 7403           JZ	089B 
1BBB:0898 80CC01         OR	AH,01 
1BBB:089B 0C08           OR	AL,08 
1BBB:089D 894610         MOV	[BP+10],AX 
1BBB:08A0 FF1E2806       CALL	FAR [0628] 
1BBB:08A4 E912F9         JMP	01B9 
1BBB:08A7 004952         ADD	[BX+DI+52],CL 
1BBB:08AA 51             PUSH	CX 
1BBB:08AB 4D             DEC	BP 
1BBB:08AC 41             INC	CX 
1BBB:08AD 53             PUSH	BX 
1BBB:08AE 4B             DEC	BX 
1BBB:08AF 3E1000         ADC	DS:[BX+SI],AL 
1BBB:08B2 0800           OR	[BX+SI],AL 
1BBB:08B4 1000           ADC	[BX+SI],AL 
1BBB:08B6 0800           OR	[BX+SI],AL 
1BBB:08B8 0000           ADD	[BX+SI],AL 
1BBB:08BA 0000           ADD	[BX+SI],AL 
1BBB:08BC 0000           ADD	[BX+SI],AL 
1BBB:08BE 0000           ADD	[BX+SI],AL 
1BBB:08C0 0000           ADD	[BX+SI],AL 
1BBB:08C2 0000           ADD	[BX+SI],AL 
1BBB:08C4 0000           ADD	[BX+SI],AL 
1BBB:08C6 0000           ADD	[BX+SI],AL 
1BBB:08C8 0000           ADD	[BX+SI],AL 
1BBB:08CA 0000           ADD	[BX+SI],AL 
1BBB:08CC 0000           ADD	[BX+SI],AL 
1BBB:08CE 0000           ADD	[BX+SI],AL 
1BBB:08D0 204952         AND	[BX+DI+52],CL 
1BBB:08D3 51             PUSH	CX 
1BBB:08D4 49             DEC	CX 
1BBB:08D5 4E             DEC	SI 
1BBB:08D6 54             PUSH	SP 
1BBB:08D7 3E0C00         OR	AL,00 
1BBB:08DA 0B00           OR	AX,DS:[BX+SI] 
1BBB:08DC 0C00           OR	AL,00 
1BBB:08DE 0B00           OR	AX,[BX+SI] 
1BBB:08E0 FF00           INC	Word Ptr [BX+SI] 
1BBB:08E2 FF00           INC	Word Ptr [BX+SI] 
1BBB:08E4 FF00           INC	Word Ptr [BX+SI] 
1BBB:08E6 FF00           INC	Word Ptr [BX+SI] 
1BBB:08E8 FF00           INC	Word Ptr [BX+SI] 
1BBB:08EA FF00           INC	Word Ptr [BX+SI] 
1BBB:08EC FF00           INC	Word Ptr [BX+SI] 
1BBB:08EE FF00           INC	Word Ptr [BX+SI] 
1BBB:08F0 FF00           INC	Word Ptr [BX+SI] 
1BBB:08F2 FF00           INC	Word Ptr [BX+SI] 
1BBB:08F4 FF00           INC	Word Ptr [BX+SI] 
1BBB:08F6 FF00           INC	Word Ptr [BX+SI] 
1BBB:08F8 20504F         AND	[BX+SI+4F],DL 
1BBB:08FB 52             PUSH	DX 
1BBB:08FC 54             PUSH	SP 
1BBB:08FD 41             INC	CX 
1BBB:08FE 44             INC	SP 
1BBB:08FF 44             INC	SP 
1BBB:0900 52             PUSH	DX 
1BBB:0901 3EF8           CLC	DS: 
1BBB:0903 03F8           ADD	DI,AX 
1BBB:0905 02E8           ADD	CH,AL 
1BBB:0907 03E8           ADD	BP,AX 
1BBB:0909 02FF           ADD	BH,BH 
1BBB:090B FFFF           ???	DI 
1BBB:090D FFFF           ???	DI 
1BBB:090F FFFF           ???	DI 
1BBB:0911 FFFF           ???	DI 
1BBB:0913 FFFF           ???	DI 
1BBB:0915 FFFF           ???	DI 
1BBB:0917 FFFF           ???	DI 
1BBB:0919 FFFF           ???	DI 
1BBB:091B FFFF           ???	DI 
1BBB:091D FFFF           ???	DI 
1BBB:091F FFFF           ???	DI 
1BBB:0921 FF5348         CALL	[BP+DI+48] 
1BBB:0924 52             PUSH	DX 
1BBB:0925 4D             DEC	BP 
1BBB:0926 41             INC	CX 
1BBB:0927 53             PUSH	BX 
1BBB:0928 4B             DEC	BX 
1BBB:0929 3E0000         ADD	DS:[BX+SI],AL 
1BBB:092C 0000           ADD	[BX+SI],AL 
1BBB:092E 0000           ADD	[BX+SI],AL 
1BBB:0930 0000           ADD	[BX+SI],AL 
1BBB:0932 0000           ADD	[BX+SI],AL 
1BBB:0934 0000           ADD	[BX+SI],AL 
1BBB:0936 0000           ADD	[BX+SI],AL 
1BBB:0938 0000           ADD	[BX+SI],AL 
1BBB:093A 0000           ADD	[BX+SI],AL 
1BBB:093C 0000           ADD	[BX+SI],AL 
1BBB:093E 0000           ADD	[BX+SI],AL 
1BBB:0940 0000           ADD	[BX+SI],AL 
1BBB:0942 0000           ADD	[BX+SI],AL 
1BBB:0944 0000           ADD	[BX+SI],AL 
1BBB:0946 0000           ADD	[BX+SI],AL 
1BBB:0948 0000           ADD	[BX+SI],AL 
1BBB:094A 53             PUSH	BX 
1BBB:094B 48             DEC	AX 
1BBB:094C 52             PUSH	DX 
1BBB:094D 50             PUSH	AX 
1BBB:094E 4F             DEC	DI 
1BBB:094F 52             PUSH	DX 
1BBB:0950 54             PUSH	SP 
1BBB:0951 3E0000         ADD	DS:[BX+SI],AL 
1BBB:0954 0000           ADD	[BX+SI],AL 
1BBB:0956 0000           ADD	[BX+SI],AL 
1BBB:0958 0000           ADD	[BX+SI],AL 
1BBB:095A 0000           ADD	[BX+SI],AL 
1BBB:095C 0000           ADD	[BX+SI],AL 
1BBB:095E 0000           ADD	[BX+SI],AL 
1BBB:0960 0000           ADD	[BX+SI],AL 
1BBB:0962 0000           ADD	[BX+SI],AL 
1BBB:0964 0000           ADD	[BX+SI],AL 
1BBB:0966 0000           ADD	[BX+SI],AL 
1BBB:0968 0000           ADD	[BX+SI],AL 
1BBB:096A 0000           ADD	[BX+SI],AL 
1BBB:096C 0000           ADD	[BX+SI],AL 
1BBB:096E 0000           ADD	[BX+SI],AL 
1BBB:0970 0000           ADD	[BX+SI],AL 
1BBB:0972 49             DEC	CX 
1BBB:0973 52             PUSH	DX 
1BBB:0974 51             PUSH	CX 
1BBB:0975 50             PUSH	AX 
1BBB:0976 4F             DEC	DI 
1BBB:0977 52             PUSH	DX 
1BBB:0978 54             PUSH	SP 
1BBB:0979 3E2000         AND	DS:[BX+SI],AL 
1BBB:097C 2000           AND	[BX+SI],AL 
1BBB:097E 2000           AND	[BX+SI],AL 
1BBB:0980 2000           AND	[BX+SI],AL 
1BBB:0982 0000           ADD	[BX+SI],AL 
1BBB:0984 0000           ADD	[BX+SI],AL 
1BBB:0986 0000           ADD	[BX+SI],AL 
1BBB:0988 0000           ADD	[BX+SI],AL 
1BBB:098A 0000           ADD	[BX+SI],AL 
1BBB:098C 0000           ADD	[BX+SI],AL 
1BBB:098E 0000           ADD	[BX+SI],AL 
1BBB:0990 0000           ADD	[BX+SI],AL 
1BBB:0992 0000           ADD	[BX+SI],AL 
1BBB:0994 0000           ADD	[BX+SI],AL 
1BBB:0996 0000           ADD	[BX+SI],AL 
1BBB:0998 0000           ADD	[BX+SI],AL 
1BBB:099A FFFF           ???	DI 
1BBB:099C FFFF           ???	DI 
1BBB:099E FFFF           ???	DI 
1BBB:09A0 FFFF           ???	DI 
1BBB:09A2 FFFF           ???	DI 
1BBB:09A4 FFFF           ???	DI 
1BBB:09A6 FFFF           ???	DI 
1BBB:09A8 FFFF           ???	DI 
1BBB:09AA FFFF           ???	DI 
1BBB:09AC FFFF           ???	DI 
1BBB:09AE FFFF           ???	DI 
1BBB:09B0 FFFF           ???	DI 
1BBB:09B2 FFFF           ???	DI 
1BBB:09B4 FFFF           ???	DI 
1BBB:09B6 FFFF           ???	DI 
1BBB:09B8 FFFF           ???	DI 
1BBB:09BA 0000           ADD	[BX+SI],AL 
1BBB:09BC 0000           ADD	[BX+SI],AL 
1BBB:09BE 0000           ADD	[BX+SI],AL 
1BBB:09C0 0000           ADD	[BX+SI],AL 
1BBB:09C2 0000           ADD	[BX+SI],AL 
1BBB:09C4 0000           ADD	[BX+SI],AL 
1BBB:09C6 0000           ADD	[BX+SI],AL 
1BBB:09C8 0000           ADD	[BX+SI],AL 
1BBB:09CA 0000           ADD	[BX+SI],AL 
1BBB:09CC 0000           ADD	[BX+SI],AL 
1BBB:09CE 0000           ADD	[BX+SI],AL 
1BBB:09D0 0000           ADD	[BX+SI],AL 
1BBB:09D2 0000           ADD	[BX+SI],AL 
1BBB:09D4 0000           ADD	[BX+SI],AL 
1BBB:09D6 0000           ADD	[BX+SI],AL 
1BBB:09D8 0000           ADD	[BX+SI],AL 
1BBB:09DA FFFF           ???	DI 
1BBB:09DC FFFF           ???	DI 
1BBB:09DE FFFF           ???	DI 
1BBB:09E0 FFFF           ???	DI 
1BBB:09E2 FFFF           ???	DI 
1BBB:09E4 FFFF           ???	DI 
1BBB:09E6 FFFF           ???	DI 
1BBB:09E8 FFFF           ???	DI 
1BBB:09EA 0000           ADD	[BX+SI],AL 
1BBB:09EC C1C181         ROL	CX,81 
1BBB:09EF 41             INC	CX 
1BBB:09F0 0100           ADD	[BX+SI],AX 
1BBB:09F2 100E0804       ADC	[0408],CL 
1BBB:09F6 0101           ADD	[BX+DI],AX 
1BBB:09F8 80FAFF         CMP	DL,FF 
1BBB:09FB 7503           JNZ	0A00 
1BBB:09FD E9B901         JMP	0BB9 
1BBB:0A00 83E20F         AND	DX,+0F 
1BBB:0A03 8BDA           MOV	BX,DX 
1BBB:0A05 D1E3           SHL	BX,1 
1BBB:0A07 8BBF6E02       MOV	DI,[BX+026E] 
1BBB:0A0B 0BFF           OR	DI,DI 
1BBB:0A0D 7405           JZ	0A14 
1BBB:0A0F 8B4D1E         MOV	CX,[DI+1E] 
1BBB:0A12 EB24           JMP	0A38 
1BBB:0A14 8A0E0801       MOV	CL,[0108] 
1BBB:0A18 32ED           XOR	CH,CH 
1BBB:0A1A 8B3E0601       MOV	DI,[0106] 
1BBB:0A1E 833D00         CMP	Word Ptr [DI],+00 
1BBB:0A21 740C           JZ	0A2F 
1BBB:0A23 033E1A01       ADD	DI,[011A] 
1BBB:0A27 E2F5           LOOP	0A1E 
1BBB:0A29 B8FFFF         MOV	AX,FFFF 
1BBB:0A2C E99901         JMP	0BC8 
1BBB:0A2F 2A0E0801       SUB	CL,[0108] 
1BBB:0A33 F6D9           NEG	CL 
1BBB:0A35 894D1E         MOV	[DI+1E],CX 
1BBB:0A38 B80F00         MOV	AX,000F 
1BBB:0A3B FEC1           INC	CL 
1BBB:0A3D F6E1           MUL	CL 
1BBB:0A3F F7D8           NEG	AX 
1BBB:0A41 055000         ADD	AX,0050 
1BBB:0A44 89454A         MOV	[DI+4A],AX 
1BBB:0A47 89BF6E02       MOV	[BX+026E],DI 
1BBB:0A4B 895502         MOV	[DI+02],DX 
1BBB:0A4E 8B878E02       MOV	AX,[BX+028E] 
1BBB:0A52 894520         MOV	[DI+20],AX 
1BBB:0A55 8BDA           MOV	BX,DX 
1BBB:0A57 8A87DA09       MOV	AL,[BX+09DA] 
1BBB:0A5B 884518         MOV	[DI+18],AL 
1BBB:0A5E D1E3           SHL	BX,1 
1BBB:0A60 8B87B008       MOV	AX,[BX+08B0] 
1BBB:0A64 88450E         MOV	[DI+0E],AL 
1BBB:0A67 8B87D808       MOV	AX,[BX+08D8] 
1BBB:0A6B 894506         MOV	[DI+06],AX 
1BBB:0A6E 8B870209       MOV	AX,[BX+0902] 
1BBB:0A72 894504         MOV	[DI+04],AX 
1BBB:0A75 8B872A09       MOV	AX,[BX+092A] 
1BBB:0A79 89450A         MOV	[DI+0A],AX 
1BBB:0A7C 8B875209       MOV	AX,[BX+0952] 
1BBB:0A80 89450C         MOV	[DI+0C],AX 
1BBB:0A83 8B877A09       MOV	AX,[BX+097A] 
1BBB:0A87 894508         MOV	[DI+08],AX 
1BBB:0A8A 8B879A09       MOV	AX,[BX+099A] 
1BBB:0A8E 894546         MOV	[DI+46],AX 
1BBB:0A91 8B87BA09       MOV	AX,[BX+09BA] 
1BBB:0A95 884511         MOV	[DI+11],AL 
1BBB:0A98 88450F         MOV	[DI+0F],AL 
1BBB:0A9B FA             CLI	 
1BBB:0A9C 8B5504         MOV	DX,[DI+04] 
1BBB:0A9F 83C204         ADD	DX,+04 
1BBB:0AA2 B003           MOV	AL,03 
1BBB:0AA4 EE             OUT	DX,AL 
1BBB:0AA5 8B5508         MOV	DX,[DI+08] 
1BBB:0AA8 42             INC	DX 
1BBB:0AA9 EC             IN	AL,DX 
1BBB:0AAA 8AE0           MOV	AH,AL 
1BBB:0AAC 0A450E         OR	AL,[DI+0E] 
1BBB:0AAF EE             OUT	DX,AL 
1BBB:0AB0 FB             STI	 
1BBB:0AB1 833D00         CMP	Word Ptr [DI],+00 
1BBB:0AB4 7517           JNZ	0ACD 
1BBB:0AB6 22650E         AND	AH,[DI+0E] 
1BBB:0AB9 886514         MOV	[DI+14],AH 
1BBB:0ABC 8A4506         MOV	AL,[DI+06] 
1BBB:0ABF B435           MOV	AH,35                         ;'5' 
1BBB:0AC1 CD21           INT	21 
1BBB:0AC3 895D1A         MOV	[DI+1A],BX 
1BBB:0AC6 8C451C         MOV	[DI+1C],ES 
1BBB:0AC9 FE060901       INC	Byte Ptr [0109] 
1BBB:0ACD 817E0E504F     CMP	Word Ptr [BP+0E],4F50 
1BBB:0AD2 7512           JNZ	0AE6 
1BBB:0AD4 C7062D020100   MOV	Word Ptr [022D],0001 
1BBB:0ADA 8B460C         MOV	AX,[BP+0C] 
1BBB:0ADD A32F02         MOV	[022F],AX 
1BBB:0AE0 8C063102       MOV	[0231],ES 
1BBB:0AE4 EB0B           JMP	0AF1 
1BBB:0AE6 33C0           XOR	AX,AX 
1BBB:0AE8 A32D02         MOV	[022D],AX 
1BBB:0AEB A32F02         MOV	[022F],AX 
1BBB:0AEE A33102         MOV	[0231],AX 
1BBB:0AF1 8A4511         MOV	AL,[DI+11] 
1BBB:0AF4 88450F         MOV	[DI+0F],AL 
1BBB:0AF7 8B452E         MOV	AX,[DI+2E] 
1BBB:0AFA 89452A         MOV	[DI+2A],AX 
1BBB:0AFD 89452C         MOV	[DI+2C],AX 
1BBB:0B00 8B453C         MOV	AX,[DI+3C] 
1BBB:0B03 894538         MOV	[DI+38],AX 
1BBB:0B06 89453A         MOV	[DI+3A],AX 
1BBB:0B09 33C0           XOR	AX,AX 
1BBB:0B0B 884519         MOV	[DI+19],AL 
1BBB:0B0E 884512         MOV	[DI+12],AL 
1BBB:0B11 894534         MOV	[DI+34],AX 
1BBB:0B14 894526         MOV	[DI+26],AX 
1BBB:0B17 884513         MOV	[DI+13],AL 
1BBB:0B1A 884510         MOV	[DI+10],AL 
1BBB:0B1D 8A4506         MOV	AL,[DI+06] 
1BBB:0B20 8B5520         MOV	DX,[DI+20] 
1BBB:0B23 B425           MOV	AH,25                         ;'%' 
1BBB:0B25 CD21           INT	21 
1BBB:0B27 8B5504         MOV	DX,[DI+04] 
1BBB:0B2A 83C202         ADD	DX,+02 
1BBB:0B2D 8B1EEA09       MOV	BX,[09EA] 
1BBB:0B31 8A87EC09       MOV	AL,[BX+09EC] 
1BBB:0B35 EE             OUT	DX,AL 
1BBB:0B36 32ED           XOR	CH,CH 
1BBB:0B38 8A8FF209       MOV	CL,[BX+09F2] 
1BBB:0B3C EC             IN	AL,DX 
1BBB:0B3D 24C0           AND	AL,C0 
1BBB:0B3F 7504           JNZ	0B45 
1BBB:0B41 EE             OUT	DX,AL 
1BBB:0B42 B90100         MOV	CX,0001 
1BBB:0B45 894D24         MOV	[DI+24],CX 
1BBB:0B48 FA             CLI	 
1BBB:0B49 83C2FF         ADD	DX,-01 
1BBB:0B4C B00F           MOV	AL,0F 
1BBB:0B4E EE             OUT	DX,AL 
1BBB:0B4F 8B5508         MOV	DX,[DI+08] 
1BBB:0B52 42             INC	DX 
1BBB:0B53 EC             IN	AL,DX 
1BBB:0B54 8A650E         MOV	AH,[DI+0E] 
1BBB:0B57 F6D4           NOT	AH 
1BBB:0B59 22C4           AND	AL,AH 
1BBB:0B5B EE             OUT	DX,AL 
1BBB:0B5C EC             IN	AL,DX 
1BBB:0B5D FB             STI	 
1BBB:0B5E 8B5504         MOV	DX,[DI+04] 
1BBB:0B61 83C202         ADD	DX,+02 
1BBB:0B64 EC             IN	AL,DX 
1BBB:0B65 83C203         ADD	DX,+03 
1BBB:0B68 EC             IN	AL,DX 
1BBB:0B69 83C201         ADD	DX,+01 
1BBB:0B6C EC             IN	AL,DX 
1BBB:0B6D 8B5504         MOV	DX,[DI+04] 
1BBB:0B70 EC             IN	AL,DX 
1BBB:0B71 EB00           JMP	0B73 
1BBB:0B73 83C202         ADD	DX,+02 
1BBB:0B76 EC             IN	AL,DX 
1BBB:0B77 83C203         ADD	DX,+03 
1BBB:0B7A EC             IN	AL,DX 
1BBB:0B7B 83C2FE         ADD	DX,-02 
1BBB:0B7E EC             IN	AL,DX 
1BBB:0B7F EB00           JMP	0B81 
1BBB:0B81 24BF           AND	AL,BF 
1BBB:0B83 EE             OUT	DX,AL 
1BBB:0B84 83C202         ADD	DX,+02 
1BBB:0B87 EC             IN	AL,DX 
1BBB:0B88 884517         MOV	[DI+17],AL 
1BBB:0B8B 83C201         ADD	DX,+01 
1BBB:0B8E EC             IN	AL,DX 
1BBB:0B8F 884516         MOV	[DI+16],AL 
1BBB:0B92 83C2FE         ADD	DX,-02 
1BBB:0B95 B00B           MOV	AL,0B 
1BBB:0B97 EE             OUT	DX,AL 
1BBB:0B98 E844F8         CALL	03DF 
1BBB:0B9B C6451000       MOV	Byte Ptr [DI+10],00 
1BBB:0B9F 807E0B51       CMP	Byte Ptr [BP+0B],51           ;'Q' 
1BBB:0BA3 7403           JZ	0BA8 
1BBB:0BA5 E8E3F9         CALL	058B 
1BBB:0BA8 833D00         CMP	Word Ptr [DI],+00 
1BBB:0BAB 750C           JNZ	0BB9 
1BBB:0BAD 833E220100     CMP	Word Ptr [0122],+00 
1BBB:0BB2 7403           JZ	0BB7 
1BBB:0BB4 E80209         CALL	14B9 
1BBB:0BB7 FF05           INC	Word Ptr [DI] 
1BBB:0BB9 FF1E1C06       CALL	FAR [061C] 
1BBB:0BBD B405           MOV	AH,05 
1BBB:0BBF A00C01         MOV	AL,[010C] 
1BBB:0BC2 89460E         MOV	[BP+0E],AX 
1BBB:0BC5 B85419         MOV	AX,1954 
1BBB:0BC8 E9EBF5         JMP	01B6 
1BBB:0BCB 0080FAFF       ADD	[BX+SI+FFFA],AL 
1BBB:0BCF 746B           JZ	0C3C 
1BBB:0BD1 E8C8F8         CALL	049C 
1BBB:0BD4 7303           JNB	0BD9 
1BBB:0BD6 E9D3F5         JMP	01AC 
1BBB:0BD9 8B5504         MOV	DX,[DI+04] 
1BBB:0BDC 83C201         ADD	DX,+01 
1BBB:0BDF 32C0           XOR	AL,AL 
1BBB:0BE1 EE             OUT	DX,AL 
1BBB:0BE2 83C201         ADD	DX,+01 
1BBB:0BE5 EE             OUT	DX,AL 
1BBB:0BE6 83C201         ADD	DX,+01 
1BBB:0BE9 EC             IN	AL,DX 
1BBB:0BEA 243F           AND	AL,3F                         ;'?' 
1BBB:0BEC EB00           JMP	0BEE 
1BBB:0BEE EE             OUT	DX,AL 
1BBB:0BEF 83C201         ADD	DX,+01 
1BBB:0BF2 FA             CLI	 
1BBB:0BF3 EC             IN	AL,DX 
1BBB:0BF4 24F7           AND	AL,F7 
1BBB:0BF6 EB00           JMP	0BF8 
1BBB:0BF8 EE             OUT	DX,AL 
1BBB:0BF9 8B5508         MOV	DX,[DI+08] 
1BBB:0BFC 42             INC	DX 
1BBB:0BFD EC             IN	AL,DX 
1BBB:0BFE 0A4514         OR	AL,[DI+14] 
1BBB:0C01 EB00           JMP	0C03 
1BBB:0C03 EE             OUT	DX,AL 
1BBB:0C04 FB             STI	 
1BBB:0C05 1E             PUSH	DS 
1BBB:0C06 8B4506         MOV	AX,[DI+06] 
1BBB:0C09 8B551A         MOV	DX,[DI+1A] 
1BBB:0C0C 8E5D1C         MOV	DS,[DI+1C] 
1BBB:0C0F B425           MOV	AH,25                         ;'%' 
1BBB:0C11 CD21           INT	21 
1BBB:0C13 1F             POP	DS 
1BBB:0C14 833E220100     CMP	Word Ptr [0122],+00 
1BBB:0C19 7403           JZ	0C1E 
1BBB:0C1B E8C808         CALL	14E6 
1BBB:0C1E 8B5D02         MOV	BX,[DI+02] 
1BBB:0C21 D1E3           SHL	BX,1 
1BBB:0C23 33C0           XOR	AX,AX 
1BBB:0C25 89876E02       MOV	[BX+026E],AX 
1BBB:0C29 A32D02         MOV	[022D],AX 
1BBB:0C2C A32F02         MOV	[022F],AX 
1BBB:0C2F A33102         MOV	[0231],AX 
1BBB:0C32 8905           MOV	[DI],AX 
1BBB:0C34 48             DEC	AX 
1BBB:0C35 894502         MOV	[DI+02],AX 
1BBB:0C38 FE0E0901       DEC	Byte Ptr [0109] 
1BBB:0C3C FF1E2006       CALL	FAR [0620] 
1BBB:0C40 E976F5         JMP	01B9 
1BBB:0C43 0080FAFF       ADD	[BX+SI+FFFA],AL 
1BBB:0C47 7439           JZ	0C82 
1BBB:0C49 E850F8         CALL	049C 
1BBB:0C4C 7303           JNB	0C51 
1BBB:0C4E E95BF5         JMP	01AC 
1BBB:0C51 8AE0           MOV	AH,AL 
1BBB:0C53 8BD1           MOV	DX,CX 
1BBB:0C55 83C204         ADD	DX,+04 
1BBB:0C58 FA             CLI	 
1BBB:0C59 EC             IN	AL,DX 
1BBB:0C5A 0C01           OR	AL,01 
1BBB:0C5C 0AE4           OR	AH,AH 
1BBB:0C5E 7520           JNZ	0C80 
1BBB:0C60 24FE           AND	AL,FE 
1BBB:0C62 FA             CLI	 
1BBB:0C63 52             PUSH	DX 
1BBB:0C64 50             PUSH	AX 
1BBB:0C65 8BD1           MOV	DX,CX 
1BBB:0C67 83C206         ADD	DX,+06 
1BBB:0C6A EC             IN	AL,DX 
1BBB:0C6B 884516         MOV	[DI+16],AL 
1BBB:0C6E C6451000       MOV	Byte Ptr [DI+10],00 
1BBB:0C72 FB             STI	 
1BBB:0C73 EB00           JMP	0C75 
1BBB:0C75 EB00           JMP	0C77 
1BBB:0C77 E865F7         CALL	03DF 
1BBB:0C7A 58             POP	AX 
1BBB:0C7B 5A             POP	DX 
1BBB:0C7C C6451000       MOV	Byte Ptr [DI+10],00 
1BBB:0C80 EE             OUT	DX,AL 
1BBB:0C81 FB             STI	 
1BBB:0C82 E934F5         JMP	01B9 
1BBB:0C85 0008           ADD	[BX+SI],CL 
1BBB:0C87 1237           ADC	DH,[BX] 
1BBB:0C89 00A1880C       ADD	[BX+DI+0C88],AH 
1BBB:0C8D 89460A         MOV	[BP+0A],AX 
1BBB:0C90 A1860C         MOV	AX,[0C86] 
1BBB:0C93 E920F5         JMP	01B6 
1BBB:0C96 80FAFF         CMP	DL,FF 
1BBB:0C99 7414           JZ	0CAF 
1BBB:0C9B E8FEF7         CALL	049C 
1BBB:0C9E 7303           JNB	0CA3 
1BBB:0CA0 E909F5         JMP	01AC 
1BBB:0CA3 837D2600       CMP	Word Ptr [DI+26],+00 
1BBB:0CA7 7406           JZ	0CAF 
1BBB:0CA9 FF1E2406       CALL	FAR [0624] 
1BBB:0CAD EBF4           JMP	0CA3 
1BBB:0CAF E907F5         JMP	01B9 
1BBB:0CB2 80FAFF         CMP	DL,FF 
1BBB:0CB5 7426           JZ	0CDD 
1BBB:0CB7 E8E2F7         CALL	049C 
1BBB:0CBA 7303           JNB	0CBF 
1BBB:0CBC E9EDF4         JMP	01AC 
1BBB:0CBF 837D2401       CMP	Word Ptr [DI+24],+01 
1BBB:0CC3 7407           JZ	0CCC 
1BBB:0CC5 8BD1           MOV	DX,CX 
1BBB:0CC7 83C202         ADD	DX,+02 
1BBB:0CCA B085           MOV	AL,85 
1BBB:0CCC FA             CLI	 
1BBB:0CCD 8B452A         MOV	AX,[DI+2A] 
1BBB:0CD0 89452C         MOV	[DI+2C],AX 
1BBB:0CD3 C745260000     MOV	Word Ptr [DI+26],0000 
1BBB:0CD8 804D1760       OR	Byte Ptr [DI+17],60           ;'`' 
1BBB:0CDC FB             STI	 
1BBB:0CDD E9D9F4         JMP	01B9 
1BBB:0CE0 80FAFF         CMP	DL,FF 
1BBB:0CE3 7447           JZ	0D2C 
1BBB:0CE5 E8B4F7         CALL	049C 
1BBB:0CE8 7303           JNB	0CED 
1BBB:0CEA E9BFF4         JMP	01AC 
1BBB:0CED FA             CLI	 
1BBB:0CEE 837D2401       CMP	Word Ptr [DI+24],+01 
1BBB:0CF2 7409           JZ	0CFD 
1BBB:0CF4 8B5504         MOV	DX,[DI+04] 
1BBB:0CF7 83C202         ADD	DX,+02 
1BBB:0CFA B083           MOV	AL,83 
1BBB:0CFC EE             OUT	DX,AL 
1BBB:0CFD 8B453A         MOV	AX,[DI+3A] 
1BBB:0D00 894538         MOV	[DI+38],AX 
1BBB:0D03 C745340000     MOV	Word Ptr [DI+34],0000 
1BBB:0D08 8BD1           MOV	DX,CX 
1BBB:0D0A 83C204         ADD	DX,+04 
1BBB:0D0D EC             IN	AL,DX 
1BBB:0D0E 0D0200         OR	AX,0002 
1BBB:0D11 EB00           JMP	0D13 
1BBB:0D13 EE             OUT	DX,AL 
1BBB:0D14 F6451201       TEST	Byte Ptr [DI+12],01 
1BBB:0D18 740D           JZ	0D27 
1BBB:0D1A F6450F08       TEST	Byte Ptr [DI+0F],08 
1BBB:0D1E 7407           JZ	0D27 
1BBB:0D20 C6451311       MOV	Byte Ptr [DI+13],11 
1BBB:0D24 E8B8F6         CALL	03DF 
1BBB:0D27 FB             STI	 
1BBB:0D28 806512FE       AND	Byte Ptr [DI+12],FE 
1BBB:0D2C E98AF4         JMP	01B9 
1BBB:0D2F 0080FAFF       ADD	[BX+SI+FFFA],AL 
1BBB:0D33 7449           JZ	0D7E 
1BBB:0D35 E864F7         CALL	049C 
1BBB:0D38 7303           JNB	0D3D 
1BBB:0D3A E96FF4         JMP	01AC 
1BBB:0D3D 8B5532         MOV	DX,[DI+32] 
1BBB:0D40 395526         CMP	[DI+26],DX 
1BBB:0D43 7205           JB	0D4A 
1BBB:0D45 33C0           XOR	AX,AX 
1BBB:0D47 E96CF4         JMP	01B6 
1BBB:0D4A FA             CLI	 
1BBB:0D4B 8B5D2A         MOV	BX,[DI+2A] 
1BBB:0D4E 8807           MOV	[BX],AL 
1BBB:0D50 43             INC	BX 
1BBB:0D51 3B5D30         CMP	BX,[DI+30] 
1BBB:0D54 7603           JBE	0D59 
1BBB:0D56 8B5D2E         MOV	BX,[DI+2E] 
1BBB:0D59 895D2A         MOV	[DI+2A],BX 
1BBB:0D5C FF4526         INC	Word Ptr [DI+26] 
1BBB:0D5F 806517BF       AND	Byte Ptr [DI+17],BF 
1BBB:0D63 804D1720       OR	Byte Ptr [DI+17],20           ;' ' 
1BBB:0D67 3B5526         CMP	DX,[DI+26] 
1BBB:0D6A 7504           JNZ	0D70 
1BBB:0D6C 806517DF       AND	Byte Ptr [DI+17],DF 
1BBB:0D70 FB             STI	 
1BBB:0D71 837D2601       CMP	Word Ptr [DI+26],+01 
1BBB:0D75 7503           JNZ	0D7A 
1BBB:0D77 E865F6         CALL	03DF 
1BBB:0D7A FF1E2C06       CALL	FAR [062C] 
1BBB:0D7E B80100         MOV	AX,0001 
1BBB:0D81 E932F4         JMP	01B6 

1BBB:0D84 833E2D0200     CMP	Word Ptr [022D],+00 
1BBB:0D89 7415           JZ	0DA0 
1BBB:0D8B 56             PUSH	SI 
1BBB:0D8C 50             PUSH	AX 
1BBB:0D8D 8B362F02       MOV	SI,[022F] 
1BBB:0D91 A13102         MOV	AX,[0231] 
1BBB:0D94 0BC6           OR	AX,SI 
1BBB:0D96 7406           JZ	0D9E 
1BBB:0D98 1E             PUSH	DS 
1BBB:0D99 8ED8           MOV	DS,AX 
1BBB:0D9B FE04           INC	Byte Ptr [SI] 
1BBB:0D9D 1F             POP	DS 
1BBB:0D9E 58             POP	AX 
1BBB:0D9F 5E             POP	SI 
1BBB:0DA0 C3             RET	 

d - key read, no timeout  0DA1
=========================================================
1BBB:0DA1 B401           MOV	AH,01 
1BBB:0DA3 CD16           INT	16 
1BBB:0DA5 B400           MOV	AH,00 
1BBB:0DA7 7503           JNZ	0DAC 
1BBB:0DA9 B8FFFF         MOV	AX,FFFF 
1BBB:0DAC E907F4         JMP	01B6 

e - key read, w/wait      0DAF
=========================================================
1BBB:0DAF 32E4           XOR	AH,AH 
1BBB:0DB1 CD16           INT	16 
1BBB:0DB3 3C03           CMP	AL,03 
1BBB:0DB5 7503           JNZ	0DBA 
1BBB:0DB7 E8CAFF         CALL	0D84 
1BBB:0DBA E9F9F3         JMP	01B6 



1BBB:0DBD 0080FAFF       ADD	[BX+SI+FFFA],AL 
1BBB:0DC1 740E           JZ	0DD1 
1BBB:0DC3 E8D6F6         CALL	049C 
1BBB:0DC6 7303           JNB	0DCB 
1BBB:0DC8 E9E1F3         JMP	01AC 
1BBB:0DCB 837D3400       CMP	Word Ptr [DI+34],+00 
1BBB:0DCF 750A           JNZ	0DDB 
1BBB:0DD1 B8FFFF         MOV	AX,FFFF 
1BBB:0DD4 FF1E2806       CALL	FAR [0628] 
1BBB:0DD8 E9DBF3         JMP	01B6 
1BBB:0DDB 8B5D38         MOV	BX,[DI+38] 
1BBB:0DDE 8A07           MOV	AL,[BX] 
1BBB:0DE0 32E4           XOR	AH,AH 
1BBB:0DE2 FF1E2C06       CALL	FAR [062C] 
1BBB:0DE6 E9CDF3         JMP	01B6 
1BBB:0DE9 0080FAFF       ADD	[BX+SI+FFFA],AL 
1BBB:0DED 7445           JZ	0E34 
1BBB:0DEF E8AAF6         CALL	049C 
1BBB:0DF2 7306           JNB	0DFA 
1BBB:0DF4 FF061F02       INC	Word Ptr [021F] 
1BBB:0DF8 EB3A           JMP	0E34 
1BBB:0DFA 8BD1           MOV	DX,CX 
1BBB:0DFC B90400         MOV	CX,0004 
1BBB:0DFF 8AD8           MOV	BL,AL 
1BBB:0E01 51             PUSH	CX 
1BBB:0E02 D2E0           SHL	AL,CL 
1BBB:0E04 59             POP	CX 
1BBB:0E05 0AC3           OR	AL,BL 
1BBB:0E07 FA             CLI	 
1BBB:0E08 085D19         OR	[DI+19],BL 
1BBB:0E0B 204519         AND	[DI+19],AL 
1BBB:0E0E 8A4519         MOV	AL,[DI+19] 
1BBB:0E11 32E4           XOR	AH,AH 
1BBB:0E13 D2E8           SHR	AL,CL 
1BBB:0E15 50             PUSH	AX 
1BBB:0E16 8065190F       AND	Byte Ptr [DI+19],0F 
1BBB:0E1A F6451902       TEST	Byte Ptr [DI+19],02 
1BBB:0E1E 7510           JNZ	0E30 
1BBB:0E20 83C201         ADD	DX,+01 
1BBB:0E23 EC             IN	AL,DX 
1BBB:0E24 A90200         TEST	AX,0002 
1BBB:0E27 7507           JNZ	0E30 
1BBB:0E29 0D0200         OR	AX,0002 
1BBB:0E2C EE             OUT	DX,AL 
1BBB:0E2D E8AFF5         CALL	03DF 
1BBB:0E30 58             POP	AX 
1BBB:0E31 FB             STI	 
1BBB:0E32 EB02           JMP	0E36 
1BBB:0E34 33C0           XOR	AX,AX 
1BBB:0E36 E97DF3         JMP	01B6 
1BBB:0E39 0080FAFF       ADD	[BX+SI+FFFA],AL 
1BBB:0E3D 7503           JNZ	0E42 
1BBB:0E3F E977F3         JMP	01B9 
1BBB:0E42 E857F6         CALL	049C 
1BBB:0E45 7303           JNB	0E4A 
1BBB:0E47 E962F3         JMP	01AC 
1BBB:0E4A 240F           AND	AL,0F 
1BBB:0E4C 8A6510         MOV	AH,[DI+10] 
1BBB:0E4F 0A4511         OR	AL,[DI+11] 
1BBB:0E52 FA             CLI	 
1BBB:0E53 88450F         MOV	[DI+0F],AL 
1BBB:0E56 0C80           OR	AL,80 
1BBB:0E58 204510         AND	[DI+10],AL 
1BBB:0E5B FB             STI	 
1BBB:0E5C F6C4FF         TEST	AH,FF 
1BBB:0E5F 7403           JZ	0E64 
1BBB:0E61 E87BF5         CALL	03DF 
1BBB:0E64 E952F3         JMP	01B9 
1BBB:0E67 0000           ADD	[BX+SI],AL 
1BBB:0E69 0033           ADD	[BP+DI],DH 
1BBB:0E6B DBB402CD10E9   ESC	1E,[SI+CD02]STCW[SI+E910] 
1BBB:0E71 46             INC	SI 
1BBB:0E72 F3             REPZ	

12 - get cursor           0E73
1BBB:0E73 33DB           XOR	BX,BX 
1BBB:0E75 B403           MOV	AH,03 
1BBB:0E77 CD10           INT	10 
1BBB:0E79 89560A         MOV	[BP+0A],DX 
1BBB:0E7C E93AF3         JMP	01B9 

13 - single char write    0E7F
1BBB:0E7F 833E680E00     CMP	Word Ptr [0E68],+00 
1BBB:0E84 741D           JZ	0EA3 
1BBB:0E86 3C09           CMP	AL,09 
1BBB:0E88 7514           JNZ	0E9E 
1BBB:0E8A 33DB           XOR	BX,BX 
1BBB:0E8C B403           MOV	AH,03 
1BBB:0E8E CD10           INT	10 
1BBB:0E90 83E207         AND	DX,+07 
1BBB:0E93 83F207         XOR	DX,+07 
1BBB:0E96 8BCA           MOV	CX,DX 
1BBB:0E98 B020           MOV	AL,20                         ;' ' 
1BBB:0E9A CD29           INT	29 
1BBB:0E9C E2FC           LOOP	0E9A 
1BBB:0E9E CD29           INT	29 
1BBB:0EA0 E916F3         JMP	01B9 
1BBB:0EA3 B402           MOV	AH,02 
1BBB:0EA5 8AD0           MOV	DL,AL 
1BBB:0EA7 CD21           INT	21 
1BBB:0EA9 E90DF3         JMP	01B9 
1BBB:0EAC B40E           MOV	AH,0E 
1BBB:0EAE B307           MOV	BL,07 
1BBB:0EB0 CD10           INT	10 
1BBB:0EB2 E904F3         JMP	01B9 
1BBB:0EB5 0000           ADD	[BX+SI],AL 
1BBB:0EB7 0000           ADD	[BX+SI],AL 
1BBB:0EB9 0000           ADD	[BX+SI],AL 
1BBB:0EBB 0000           ADD	[BX+SI],AL 
1BBB:0EBD 0000           ADD	[BX+SI],AL 
1BBB:0EBF 0000           ADD	[BX+SI],AL 
1BBB:0EC1 0000           ADD	[BX+SI],AL 
1BBB:0EC3 0000           ADD	[BX+SI],AL 
1BBB:0EC5 0014           ADD	[SI],DL 
1BBB:0EC7 0F19           CTS	19 
1BBB:0EC9 0F1F           CTS	1F 
1BBB:0ECB 0F25           CTS	25 
1BBB:0ECD 0F2B           CTS	2B 
1BBB:0ECF 0F31           CTS	31 
1BBB:0ED1 0F37           CTS	37 
1BBB:0ED3 0F3D           CTS	3D 
1BBB:0ED5 0F43           CTS	43 
1BBB:0ED7 0F49           CTS	49 
1BBB:0ED9 0F4F           CTS	4F 
1BBB:0EDB 0F55           CTS	55 
1BBB:0EDD 0F5B           CTS	5B 
1BBB:0EDF 0F61           CTS	61 
1BBB:0EE1 0F67           CTS	67 
1BBB:0EE3 0F6D           CTS	6D 
1BBB:0EE5 0F80           CTS	80 
1BBB:0EE7 FA             CLI	 
1BBB:0EE8 FF7503         PUSH	[DI+03] 
1BBB:0EEB E9CBF2         JMP	01B9 
1BBB:0EEE 83FA10         CMP	DX,+10 
1BBB:0EF1 7203           JB	0EF6 
1BBB:0EF3 E9B6F2         JMP	01AC 
1BBB:0EF6 8ADA           MOV	BL,DL 
1BBB:0EF8 32FF           XOR	BH,BH 
1BBB:0EFA D1E3           SHL	BX,1 
1BBB:0EFC 2401           AND	AL,01 
1BBB:0EFE 3A87B60E       CMP	AL,[BX+0EB6] 

