#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>

void FOSSinit(int);
void FOSSputc(int, unsigned char);
int FOSSgetc(int);
unsigned int FOSSstatus(int);
unsigned int FOSSbaud(int, unsigned char);
void FOSSflowCtrl(int, unsigned char);
unsigned int FOSSpeek(int);

void main(void)
{
	unsigned int c;

	FOSSinit(4);
	FOSSbaud(4, 0x23);	// 38400,N,8,1

	while (1)
	{
		while (!kbhit())
		{	c= FOSSpeek(4);
			printf("peek= %04x\r",c);
		}

		c= getchar();

		printf("\r\n");

		while (FOSSstatus(4) & 1)
		{	c= FOSSgetc(4);
			putchar(c);
		}

		printf("\r\n");
	}
}

void FOSSinit(int port)
{
asm	mov dx,port
asm	mov ah,4
asm	int 0x14
}

unsigned int FOSSbaud(int port, unsigned char baud)
{
asm	mov dx,port
asm	mov al,baud
asm	mov ah,0
asm	int 0x14

	return(_AX);
}

void FOSSputc(int port, unsigned char c)
{
asm	mov dx,port
asm	mov al,c
asm	mov ah,1
asm	int 0x14
}

int FOSSgetc(int port)
{
asm	mov dx,port
asm	mov ah,2
asm	int 0x14

	return(_AX);
}

unsigned int FOSSstatus(int port)
{
asm	mov dx,port
asm	mov ah,3
asm	int 0x14

	return(_AX);
}

void FOSSflowCtrl(int port, unsigned char mode)
{
asm	mov dx,port
asm	mov al, mode
asm	mov ah, 0x0f
asm	int 0x14
}

unsigned int FOSSpeek(int port)
{
asm	mov dx,port
asm	mov ah,0x0c
asm	int 0x14

	return(_AX);
}

